import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Random;

class ALNS {
	double bestShift;
	double currentShift;
	StowagePlan stowageplan;
	int exitI;
	int exitJ;
	double prcShiftCost = 0.04;
	double prcRouteCost = 0.02;
	double prcNumShift = 0.02;
	int port = 1;
	Random randomRemoval = new Random();
	double chosenRandom = randomRemoval.nextDouble();
	double[] cargoRandom;
	int PRnOptSet;
	int PRchosenOptSet;
	int PRnRows;
	int PRnColumns;
	int PRnSquares;
	int PRnCargoes;
	int PRnCargoesO;
	double PRrevenue;
	double PRareaApprox;
	double PRareaUsed;
	double PRareaUsedPercentage;
	double PRshiftCost;
	double PRInitialShiftCost;
	
	ALNS(StowagePlan initialGRASP, int exitI, int exitJ){
		this.stowageplan = initialGRASP;
		this.exitI = exitI;
		this.exitJ = exitJ;
		this.cargoRandom = new double[initialGRASP.nCargoes];
		for (int c = 0; c < initialGRASP.nCargoes; c++) {
			this.cargoRandom[c] = 0;
		}
	}
	


	void runnew(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, double scale, String input) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		
		long startTime = System.currentTimeMillis();
		System.out.println();
		System.out.println("#################");
		System.out.println("#     ALNS      #");
		System.out.println("#################");
		
		String result = "results_"+input;
		PrintWriter writer = new PrintWriter(result, "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		ShiftingResult temp1 = new ShiftingResult(stowageplan);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		PRInitialShiftCost = best1.totalShiftCost;
		int dest=1;
		int rep=1;
		
		
		for(int c = 0; c < stowageplan.nCargoes; c++){
			for(int v = 0; v < stowageplan.maxVehicle; v++){
				temp1.numRouteLength[c][v][0] = best1.numRouteLength[c][v][0];
				temp1.numRouteLength[c][v][1] = best1.numRouteLength[c][v][1];
				
				temp1.routeCost[c][v][0] = best1.routeCost[c][v][0];
				temp1.routeCost[c][v][1] = best1.routeCost[c][v][1];
				
				
				temp1.shiftCostCV[c][v] = best1.shiftCostCV[c][v];
				temp1.numShiftCV[c][v] = best1.numShiftCV[c][v];
				for(int p = 0; p < stowageplan.nPorts; p++){
					temp1.numShift[c][v][p] = best1.numShift[c][v][p];
				}
			}
		}
		

		
		
		
		
		
		
		
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		
		PRnCargoesO = 0;
		String A = "";
		
		for(int c = 0; c < OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried.length; c++){
			if (OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried[c] == 1){
				PRnCargoesO++;
				A = A + (c+stowageplan.nCargoesM) + ", ";
			}
		}
		PRnCargoes = PRnCargoesO + currentStowagePlan.nCargoesM;
		
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		System.out.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					long iterTime = System.currentTimeMillis();
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					
					/*
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					*/
					
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = randomRemoval.nextDouble()*destroy2temp;
						prcRouteCost = 0;
						prcNumShift = 0;
						stowageplan.destroyOperator6_shift(prcShiftCost, prcRouteCost, prcNumShift, temp1, Cargoes, exitI, exitJ);
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage;
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = randomRemoval.nextInt(stowageplan.nRows);
						int j_start = randomRemoval.nextInt(stowageplan.nColumns);
						int i_end = (int) (i_start + randomRemoval.nextInt(stowageplan.nRows-i_start)*maxDestroyPercentage);
						int j_end = (int) (j_start + randomRemoval.nextInt(stowageplan.nColumns-j_start)*maxDestroyPercentage);
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = 0;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = 0;
						stowageplan.destroyOperator6_route(prcShiftCost, prcRouteCost, prcNumShift, temp1, Cargoes, exitI, exitJ);
					}
					
					
					
		
					////////////////////////////////////////////////////////////
					//Repair
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					int breaker = 0;
					
					for(int i = 0; i < stowageplan.nRows; i++){
						for(int j = 0; j < stowageplan.nColumns; j++){
							for(int c = 0; c < stowageplan.nCargoes; c++){
								if(stowageplan.flowX[i][j][c] != currentStowagePlan.flowX[i][j][c]){
									breaker = 1;
									break;
								}
							}
							if (breaker==1){
								break;
							}
						}
						if (breaker==1){
							break;
						}
					}
					if (breaker==0){
						evaluate = 0;
					}
					
					
					
					
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					//Evaluerer resultat
					if (q==0 && s==0 && m==0){
						temperature = -(bestShift*(1+scale)-bestShift)/Math.log(0.5);
					}
					
					if (currentShift == temp.totalShiftCost){
						evaluate = 0;
					}
					
					int useSame = 1;
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						if (temperature != 0){
							simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
							simulatedRandom = randomRemoval.nextDouble();
							//System.out.println(simulatedRandom);
							if (simulated>simulatedRandom){
								useSame = 0;
								//System.out.println("Accepted!!!!!");
								for(int i = 0; i < stowageplan.nRows; i++){
									for(int j = 0; j < stowageplan.nColumns; j++){
										for(int c = 0; c < stowageplan.nCargoes; c++){
											currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
										}
									}
								}
								currentStowagePlan.calculateGrouing(Cargoes);
								currentStowagePlan.calculatePlacement(Cargoes);
								currentGroup = currentStowagePlan.groupObjective;
								currentPlacement = currentStowagePlan.placementObjective;
								currentShift = temp.totalShiftCost;
								scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
								scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
								for(int c = 0; c < stowageplan.nCargoes; c++){
									for(int v = 0; v < stowageplan.maxVehicle; v++){
										temp1.numRouteLength[c][v][0] = temp.numRouteLength[c][v][0];
										temp1.numRouteLength[c][v][1] = temp.numRouteLength[c][v][1];
										
										temp1.routeCost[c][v][0] = temp.routeCost[c][v][0];
										temp1.routeCost[c][v][1] = temp.routeCost[c][v][1];
										
										
										temp1.shiftCostCV[c][v] = temp.shiftCostCV[c][v];
										temp1.numShiftCV[c][v] = temp.numShiftCV[c][v];
										for(int p = 0; p < stowageplan.nPorts; p++){
											temp1.numShift[c][v][p] = temp.numShift[c][v][p];
										}
									}
								}
							}
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						useSame = 0;
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						for(int c = 0; c < stowageplan.nCargoes; c++){
							for(int v = 0; v < stowageplan.maxVehicle; v++){
								temp1.numRouteLength[c][v][0] = temp.numRouteLength[c][v][0];
								temp1.numRouteLength[c][v][1] = temp.numRouteLength[c][v][1];
								
								temp1.routeCost[c][v][0] = temp.routeCost[c][v][0];
								temp1.routeCost[c][v][1] = temp.routeCost[c][v][1];
								
								
								temp1.shiftCostCV[c][v] = temp.shiftCostCV[c][v];
								temp1.numShiftCV[c][v] = temp.numShiftCV[c][v];
								for(int p = 0; p < stowageplan.nPorts; p++){
									temp1.numShift[c][v][p] = temp.numShift[c][v][p];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					System.out.println((n+1) + "\t" + "\t" + currentShift1  + "\t" + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + "\t" + currentShift  + "\t" + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
					if (useSame == 1 && evaluate!=0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		
		
		
		
		
		
		//bestStowagePlan.printFlowX(Cargoes, UnusableSpace, ExitSquares);
		bestStowagePlan.setNewVehiclePlacement(Cargoes);
		bestStowagePlan.printVehiclePlacementToFile(Cargoes, UnusableSpace, ExitSquares, input);
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		System.out.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		System.out.println("unknown" + "\t" + "\t" + endTime + "\t" + "\t" + PRnOptSet + "\t"  + "\t" + PRchosenOptSet + "\t"  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + "\t" + PRnSquares  + "\t" + "\t" + PRnCargoes  + "\t" + "\t" + PRnCargoesO  + "\t" + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + "\t" + "\t" + PRareaUsed  + "\t" + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t"+ "\t" + PRInitialShiftCost + "\t"+ "\t"+ "\t" + A );
		
		writer.println();
		writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRInitialShiftCost + "\t" + A);
		
		
		
		
		writer.close();
		
	}
	

	void runnewGRASPONLY(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, double scale, String input) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		
		long startTime = System.currentTimeMillis();
		System.out.println();
		System.out.println("#################");
		System.out.println("#     ALNS      #");
		System.out.println("#################");
		
		String result = "results_GRASPONLY_"+input;
		PrintWriter writer = new PrintWriter(result, "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		PRInitialShiftCost = best1.totalShiftCost;
		int dest=1;
		int rep=1;
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		
		PRnCargoesO = 0;
		String A = "";
		
		for(int c = 0; c < OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried.length; c++){
			if (OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried[c] == 1){
				PRnCargoesO++;
				A = A + (c+stowageplan.nCargoesM) + ", ";
			}
		}
		PRnCargoes = PRnCargoesO + currentStowagePlan.nCargoesM;
		
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		System.out.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					long iterTime = System.currentTimeMillis();
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					dest = 4;
					/*
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					*/
					
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = randomRemoval.nextDouble()*destroy2temp;
						prcRouteCost = 0;
						prcNumShift = 0;
						stowageplan.destroyOperator6_shift(prcShiftCost, prcRouteCost, prcNumShift, temp, Cargoes, exitI, exitJ);
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage;
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = 0;
						int j_start = 0;
						int i_end = stowageplan.nRows;
						int j_end = stowageplan.nRows;
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = 0;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = 0;
						stowageplan.destroyOperator6_route(prcShiftCost, prcRouteCost, prcNumShift, temp, Cargoes, exitI, exitJ);
					}
					
					
					
		
					////////////////////////////////////////////////////////////
					//Repair
					rep = 1;
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					int breaker = 0;
					
					for(int i = 0; i < stowageplan.nRows; i++){
						for(int j = 0; j < stowageplan.nColumns; j++){
							for(int c = 0; c < stowageplan.nCargoes; c++){
								if(stowageplan.flowX[i][j][c] != currentStowagePlan.flowX[i][j][c]){
									breaker = 1;
									break;
								}
							}
							if (breaker==1){
								break;
							}
						}
						if (breaker==1){
							break;
						}
					}
					if (breaker==0){
						evaluate = 0;
					}
					
					
					
					
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					//Evaluerer resultat
					if (q==0 && s==0 && m==0){
						temperature = -(bestShift*(1+scale)-bestShift)/Math.log(0.5);
					}
					
					
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						if (temperature != 0){
							simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
							simulatedRandom = randomRemoval.nextDouble();
							//System.out.println(simulatedRandom);
							if (simulated>simulatedRandom){
								//System.out.println("Accepted!!!!!");
								for(int i = 0; i < stowageplan.nRows; i++){
									for(int j = 0; j < stowageplan.nColumns; j++){
										for(int c = 0; c < stowageplan.nCargoes; c++){
											currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
										}
									}
								}
								currentStowagePlan.calculateGrouing(Cargoes);
								currentStowagePlan.calculatePlacement(Cargoes);
								currentGroup = currentStowagePlan.groupObjective;
								currentPlacement = currentStowagePlan.placementObjective;
								currentShift = temp.totalShiftCost;
								scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
								scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
							}
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					System.out.println((n+1) + "\t" + "\t" + currentShift1  + "\t" + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + "\t" + currentShift  + "\t" + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		
		
		
		
		
		
		//bestStowagePlan.printFlowX(Cargoes, UnusableSpace, ExitSquares);
		bestStowagePlan.setNewVehiclePlacement(Cargoes);
		bestStowagePlan.printVehiclePlacementToFileGRASPONLY(Cargoes, UnusableSpace, ExitSquares, input);
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		System.out.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		System.out.println("unknown" + "\t" + "\t" + endTime + "\t" + "\t" + PRnOptSet + "\t"  + "\t" + PRchosenOptSet + "\t"  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + "\t" + PRnSquares  + "\t" + "\t" + PRnCargoes  + "\t" + "\t" + PRnCargoesO  + "\t" + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + "\t" + "\t" + PRareaUsed  + "\t" + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t"+ "\t" + PRInitialShiftCost + "\t"+ "\t"+ "\t" + A );
		
		writer.println();
		writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRInitialShiftCost + "\t" + A);
		
		
		
		
		writer.close();
		
	}
	

	void runMIPinstancesLOG(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, double scale, String input, int shift, long[] res) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		double shiftfound = 0;
		long startTime = System.currentTimeMillis();
		
		String result = "results_"+input;
		PrintWriter writer = new PrintWriter(result, "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		ShiftingResult temp1 = new ShiftingResult(stowageplan);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		PRInitialShiftCost = best1.totalShiftCost;
		int dest=1;
		int rep=1;
		startTime = System.currentTimeMillis();
		
		if (bestShift <= shift && shiftfound == 0){
			shiftfound = 1;
			res[0] = (System.currentTimeMillis()-startTime);
		}
		
		for(int c = 0; c < stowageplan.nCargoes; c++){
			for(int v = 0; v < stowageplan.maxVehicle; v++){
				temp1.numRouteLength[c][v][0] = best1.numRouteLength[c][v][0];
				temp1.numRouteLength[c][v][1] = best1.numRouteLength[c][v][1];
				
				temp1.routeCost[c][v][0] = best1.routeCost[c][v][0];
				temp1.routeCost[c][v][1] = best1.routeCost[c][v][1];
				
				
				temp1.shiftCostCV[c][v] = best1.shiftCostCV[c][v];
				temp1.numShiftCV[c][v] = best1.numShiftCV[c][v];
				for(int p = 0; p < stowageplan.nPorts; p++){
					temp1.numShift[c][v][p] = best1.numShift[c][v][p];
				}
			}
		}
		

		
		
		
		
		
		
		
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		
		PRnCargoesO = 0;
		String A = "";
		
		for(int c = 0; c < OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried.length; c++){
			if (OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried[c] == 1){
				PRnCargoesO++;
				A = A + (c+stowageplan.nCargoesM) + ", ";
			}
		}
		PRnCargoes = PRnCargoesO + currentStowagePlan.nCargoesM;
		
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		//System.out.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		//writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "Time");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					long iterTime = System.currentTimeMillis();
					if (bestShift <= shift && shiftfound == 0){
						shiftfound = 1;
						res[0] = (System.currentTimeMillis()-startTime);
					}
					
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					
					/*
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					*/
					
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = randomRemoval.nextDouble()*destroy2temp;
						prcRouteCost = 0;
						prcNumShift = 0;
						stowageplan.destroyOperator6_shift(prcShiftCost, prcRouteCost, prcNumShift, temp1, Cargoes, exitI, exitJ);
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage;
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = randomRemoval.nextInt(stowageplan.nRows);
						int j_start = randomRemoval.nextInt(stowageplan.nColumns);
						int i_end = (int) (i_start + randomRemoval.nextInt(stowageplan.nRows-i_start)*maxDestroyPercentage);
						int j_end = (int) (j_start + randomRemoval.nextInt(stowageplan.nColumns-j_start)*maxDestroyPercentage);
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*0.4;
						prcShiftCost = 0;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = 0;
						stowageplan.destroyOperator6_route(prcShiftCost, prcRouteCost, prcNumShift, temp1, Cargoes, exitI, exitJ);
					}
					
					
					
		
					////////////////////////////////////////////////////////////
					//Repair
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					int breaker = 0;
					
					for(int i = 0; i < stowageplan.nRows; i++){
						for(int j = 0; j < stowageplan.nColumns; j++){
							for(int c = 0; c < stowageplan.nCargoes; c++){
								if(stowageplan.flowX[i][j][c] != currentStowagePlan.flowX[i][j][c]){
									breaker = 1;
									break;
								}
							}
							if (breaker==1){
								break;
							}
						}
						if (breaker==1){
							break;
						}
					}
					if (breaker==0){
						evaluate = 0;
					}
					
					
					
					
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					
					//Evaluerer resultat
					if (q==0 && s==0 && m==0){
						temperature = -(bestShift*(1+scale)-bestShift)/Math.log(0.5);
					}
					
					if (currentShift == temp.totalShiftCost){
						evaluate = 0;
					}
					
					int useSame = 1;
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						if (temperature != 0){
							simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
							simulatedRandom = randomRemoval.nextDouble();
							//System.out.println(simulatedRandom);
							if (simulated>simulatedRandom){
								useSame = 0;
								//System.out.println("Accepted!!!!!");
								for(int i = 0; i < stowageplan.nRows; i++){
									for(int j = 0; j < stowageplan.nColumns; j++){
										for(int c = 0; c < stowageplan.nCargoes; c++){
											currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
										}
									}
								}
								currentStowagePlan.calculateGrouing(Cargoes);
								currentStowagePlan.calculatePlacement(Cargoes);
								currentGroup = currentStowagePlan.groupObjective;
								currentPlacement = currentStowagePlan.placementObjective;
								currentShift = temp.totalShiftCost;
								scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
								scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
								for(int c = 0; c < stowageplan.nCargoes; c++){
									for(int v = 0; v < stowageplan.maxVehicle; v++){
										temp1.numRouteLength[c][v][0] = temp.numRouteLength[c][v][0];
										temp1.numRouteLength[c][v][1] = temp.numRouteLength[c][v][1];
										
										temp1.routeCost[c][v][0] = temp.routeCost[c][v][0];
										temp1.routeCost[c][v][1] = temp.routeCost[c][v][1];
										
										
										temp1.shiftCostCV[c][v] = temp.shiftCostCV[c][v];
										temp1.numShiftCV[c][v] = temp.numShiftCV[c][v];
										for(int p = 0; p < stowageplan.nPorts; p++){
											temp1.numShift[c][v][p] = temp.numShift[c][v][p];
										}
									}
								}
							}
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						useSame = 0;
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						for(int c = 0; c < stowageplan.nCargoes; c++){
							for(int v = 0; v < stowageplan.maxVehicle; v++){
								temp1.numRouteLength[c][v][0] = temp.numRouteLength[c][v][0];
								temp1.numRouteLength[c][v][1] = temp.numRouteLength[c][v][1];
								
								temp1.routeCost[c][v][0] = temp.routeCost[c][v][0];
								temp1.routeCost[c][v][1] = temp.routeCost[c][v][1];
								
								
								temp1.shiftCostCV[c][v] = temp.shiftCostCV[c][v];
								temp1.numShiftCV[c][v] = temp.numShiftCV[c][v];
								for(int p = 0; p < stowageplan.nPorts; p++){
									temp1.numShift[c][v][p] = temp.numShift[c][v][p];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					//System.out.println((n+1) + "\t" + "\t" + currentShift1  + "\t" + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + "\t" + currentShift  + "\t" + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					//writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3] + "\t" + (System.currentTimeMillis()-iterTime));
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
					if (useSame == 1 && evaluate!=0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		if (bestShift <= shift && shiftfound == 0){
			shiftfound = 1;
			res[0] = (System.currentTimeMillis()-startTime);;
		}
		
		if (shiftfound == 0){
			shiftfound = 1;
			res[0] = (-1);
		}
		
		
		
		//bestStowagePlan.printFlowX(Cargoes, UnusableSpace, ExitSquares);
		bestStowagePlan.setNewVehiclePlacement(Cargoes);
		//bestStowagePlan.printVehiclePlacementToFile(Cargoes, UnusableSpace, ExitSquares, input);
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		//System.out.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		//System.out.println("unknown" + "\t" + "\t" + endTime + "\t" + "\t" + PRnOptSet + "\t"  + "\t" + PRchosenOptSet + "\t"  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + "\t" + PRnSquares  + "\t" + "\t" + PRnCargoes  + "\t" + "\t" + PRnCargoesO  + "\t" + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + "\t" + "\t" + PRareaUsed  + "\t" + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t"+ "\t" + PRInitialShiftCost + "\t"+ "\t"+ "\t" + A );
		
		//writer.println();
		//writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		//writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRInitialShiftCost + "\t" + A);
		
		
		
		
		writer.close();
		
	}
	
	//OLD methods

	void run(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, double scale) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		
		long startTime = System.currentTimeMillis();
		System.out.println();
		System.out.println("#################");
		System.out.println("#     ALNS      #");
		System.out.println("#################");
		
		
		PrintWriter writer = new PrintWriter("result.txt", "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		PRInitialShiftCost = best1.totalShiftCost;
		int dest=1;
		int rep=1;
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		
		PRnCargoesO = 0;
		String A = "";
		
		for(int c = 0; c < OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried.length; c++){
			if (OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried[c] == 1){
				PRnCargoesO++;
				A = A + (c+stowageplan.nCargoesM) + ", ";
			}
		}
		PRnCargoes = PRnCargoesO + currentStowagePlan.nCargoesM;
		
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		System.out.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "WR5");
		writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "WR5");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					
					/*
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					*/
					
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						stowageplan.destroyOperator2(cargoRandom, Cargoes); 
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = randomRemoval.nextInt(stowageplan.nRows);
						int j_start = randomRemoval.nextInt(stowageplan.nColumns);
						int i_end = (int) (i_start + randomRemoval.nextInt(stowageplan.nRows-i_start)*maxDestroyPercentage);
						int j_end = (int) (j_start + randomRemoval.nextInt(stowageplan.nColumns-j_start)*maxDestroyPercentage);
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						prcShiftCost = 0;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = 0;
						stowageplan.destroyOperator6(prcShiftCost, prcRouteCost, prcNumShift, temp, Cargoes);
					}
					
					
					
		
					////////////////////////////////////////////////////////////
					//Repair
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					int breaker = 0;
					
					for(int i = 0; i < stowageplan.nRows; i++){
						for(int j = 0; j < stowageplan.nColumns; j++){
							for(int c = 0; c < stowageplan.nCargoes; c++){
								if(stowageplan.flowX[i][j][c] != currentStowagePlan.flowX[i][j][c]){
									breaker = 1;
									break;
								}
							}
							if (breaker==1){
								break;
							}
						}
						if (breaker==1){
							break;
						}
					}
					if (breaker==0){
						evaluate = 0;
					}
					
					
					
					
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					//Evaluerer resultat
					if (q==0 && s==0 && m==0){
						temperature = -(bestShift*(1+scale)-bestShift)/Math.log(0.5);
					}
					
					
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						if (temperature != 0){
							simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
							simulatedRandom = randomRemoval.nextDouble();
							//System.out.println(simulatedRandom);
							if (simulated>simulatedRandom){
								//System.out.println("Accepted!!!!!");
								for(int i = 0; i < stowageplan.nRows; i++){
									for(int j = 0; j < stowageplan.nColumns; j++){
										for(int c = 0; c < stowageplan.nCargoes; c++){
											currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
										}
									}
								}
								currentStowagePlan.calculateGrouing(Cargoes);
								currentStowagePlan.calculatePlacement(Cargoes);
								currentGroup = currentStowagePlan.groupObjective;
								currentPlacement = currentStowagePlan.placementObjective;
								currentShift = temp.totalShiftCost;
								scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
								scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
							}
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					System.out.println((n+1) + "\t" + "\t" + currentShift1  + "\t" + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + "\t" + currentShift  + "\t" + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3]);
					writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3]);
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		
		
		
		
		
		
		bestStowagePlan.printFlowX(Cargoes, UnusableSpace, ExitSquares);
		bestStowagePlan.printFlowXToFile(Cargoes, UnusableSpace, ExitSquares);
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		System.out.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		System.out.println("unknown" + "\t" + "\t" + endTime + "\t" + "\t" + PRnOptSet + "\t"  + "\t" + PRchosenOptSet + "\t"  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + "\t" + PRnSquares  + "\t" + "\t" + PRnCargoes  + "\t" + "\t" + PRnCargoesO  + "\t" + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + "\t" + "\t" + PRareaUsed  + "\t" + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t"+ "\t" + PRInitialShiftCost + "\t"+ "\t"+ "\t" + A );
		
		writer.println();
		writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRInitialShiftCost + "\t" + A);
		
		
		
		
		writer.close();
		
	}
	
	
	void runtest(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, double scale) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		
		long startTime = System.currentTimeMillis();
		
		
		
		PrintWriter writer = new PrintWriter("result.txt", "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		PRInitialShiftCost = best1.totalShiftCost;
		int dest=1;
		int rep=1;
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		
		PRnCargoesO = 0;
		String A = "";
		
		for(int c = 0; c < OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried.length; c++){
			if (OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].CargoesCarried[c] == 1){
				PRnCargoesO++;
				A = A + (c+stowageplan.nCargoesM) + ", ";
			}
		}
		PRnCargoes = PRnCargoesO + currentStowagePlan.nCargoesM;
		
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "WR5");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					
					/*
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					*/
					
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						stowageplan.destroyOperator2(cargoRandom, Cargoes); 
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = randomRemoval.nextInt(stowageplan.nRows);
						int j_start = randomRemoval.nextInt(stowageplan.nColumns);
						int i_end = (int) (i_start + randomRemoval.nextInt(stowageplan.nRows-i_start)*maxDestroyPercentage);
						int j_end = (int) (j_start + randomRemoval.nextInt(stowageplan.nColumns-j_start)*maxDestroyPercentage);
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						prcShiftCost = randomRemoval.nextDouble()*destroy2temp;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = randomRemoval.nextDouble()*destroy2temp;
						stowageplan.destroyOperator6(prcShiftCost, prcRouteCost, prcNumShift, temp, Cargoes);
					}
					
		
					////////////////////////////////////////////////////////////
					//Repair
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					if (q==0 && s==0 && m==0){
						temperature = -(bestShift*(1+scale)-bestShift)/Math.log(0.5);
					}
					System.out.println(temperature);
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					//Evaluerer resultat
					
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
						//System.out.println(simulated);
						simulatedRandom = randomRemoval.nextDouble();
						//System.out.println(simulatedRandom);
						if (simulated>simulatedRandom){
							//System.out.println("Accepted!!!!!");
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							currentStowagePlan.calculateGrouing(Cargoes);
							currentStowagePlan.calculatePlacement(Cargoes);
							currentGroup = currentStowagePlan.groupObjective;
							currentPlacement = currentStowagePlan.placementObjective;
							currentShift = temp.totalShiftCost;
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3]);
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		
		
		
		
		
		
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		
		
		writer.println();
		writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost"+ "\t" + "OptCargoesCarried");
		
		writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRInitialShiftCost + "\t" + A);
		
		
		
		
		writer.close();
		
	}
	

	void runGRASPOnly(Cargo[] Cargoes, OptionalSet[] OptionalSets, int [][][]possibleSquares, int[][][]possibleSquaresWithExit, int[][] UnusableSpace, int[][] ExitSquares, double[] InitialWeightDestroy, double[] InitialWeightRepair, double score1, double score2, double score3, double score4, double temperature, double coolingRate, double r, int sizeSegment, int weightResetSegments, long runTimeALNS, double percentGrouping, double percentPlacement, long maxRunTimeRepair, int deltaWeight, double maxDestroyPercentage, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares) throws FileNotFoundException, UnsupportedEncodingException{
		
		
		
		long startTime = System.currentTimeMillis();
		System.out.println();
		System.out.println("#################");
		System.out.println("#     ALNS      #");
		System.out.println("#################");
		
		
		PrintWriter writer = new PrintWriter("result.txt", "UTF-8");
	
		
		
		
		
		
		stowageplan.setNewVehiclePlacement(Cargoes);
		PRareaApprox = 0;
		PRareaUsed = 0;
		//Lagrer beste initielt
		StowagePlan currentStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		StowagePlan bestStowagePlan = new StowagePlan(stowageplan.nRows,stowageplan.nColumns,stowageplan.nCargoesM,stowageplan.nCargoesO,OptionalSets, stowageplan.optionalSetNumberEvaluated, stowageplan.nPorts, Cargoes,possibleSquares);
		for(int i = 0; i < stowageplan.nRows; i++){
			for(int j = 0; j < stowageplan.nColumns; j++){
				if (UnusableSpace[i][j]==0 && ExitSquares[i][j]==0){
					PRareaApprox++;
				}
				for(int c = 0; c < stowageplan.nCargoes; c++){
					currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
					if (currentStowagePlan.flowX[i][j][c]==1){
						PRareaUsed = PRareaUsed + Cargoes[c].Area;
					}
				}
			}
		}
		PRareaUsedPercentage = 0;
		PRareaUsedPercentage = PRareaUsed/PRareaApprox;
			
		//Kjrer dijkstra p initiell lsning
		currentStowagePlan.setNewVehiclePlacement(Cargoes);
		ShiftingResult best1 = new ShiftingResult(currentStowagePlan);
		best1.dijkstra(currentStowagePlan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
		//System.out.println("Initial solution shiftCost: " + best1.totalShiftCost);
		currentShift = best1.totalShiftCost;
		bestShift = best1.totalShiftCost;
		ShiftingResult temp = new ShiftingResult(stowageplan);
		
		int dest=1;
		int rep=1;
		
		PRnOptSet = OptionalSets.length;
		PRchosenOptSet = currentStowagePlan.optionalSetNumberEvaluated;
		PRnRows = currentStowagePlan.nRows;
		PRnColumns  = currentStowagePlan.nColumns;
		PRnSquares = currentStowagePlan.nColumns*currentStowagePlan.nRows;
		PRnCargoes = currentStowagePlan.nCargoes;
		PRnCargoesO = currentStowagePlan.nCargoesO;
		PRrevenue = OptionalSets[currentStowagePlan.optionalSetNumberEvaluated].Revenue;
		
		
		
		
		
		stowageplan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		currentStowagePlan.setSquareCost(possibleSquaresWithExit, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
		System.out.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "WR5");
		writer.println("Iteration #" + "\t" + "Current Shift" + "\t" + "Destroy" + "\t" + "Repair" + "\t" + "This shift" + "\t" + "New Shift" + "\t" + "WD1" + "\t" + "WD2" + "\t" + "WD3" + "\t" + "WD4" + "\t" + "WD5" + "\t" + "WD6" + "\t" + "WR1" + "\t" + "WR2" + "\t" + "WR3" + "\t" + "WR4" + "\t" + "WR5");
		double currentShift1;
		double simulated;
		double simulatedRandom;
		currentStowagePlan.calculateGrouing(Cargoes);
		currentStowagePlan.calculatePlacement(Cargoes);
		double currentGroup = currentStowagePlan.groupObjective;
		double currentPlacement = currentStowagePlan.placementObjective;
		double thisGroup;
		double thisPlacement;
		int evaluate = 0;
		int destroyPossible = 0;
		double destroy2temp;
		
		
		//Parameters
		double tempsum;
		double[] NomalizedWeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] NomalizedWeightRepair = {1, 1, 1, 1};
		double[] WeightDestroy = {1, 1, 1, 1, 1, 1};
		double[] WeightRepair = {1, 1, 1, 1};
		double[] scoreDestroy = {0,0,0,0,0,0};
		double[] scoreRepair = {0,0,0,0};
		double[] attemptDestroy = {0,0,0,0,0,0};
		double[] attemptRepair = {0,0,0,0};

		//Her nsker vi  forbedre lsningen.
		int n = 0;
		int q = 0;
		while (q == 0){
			for(int b = 0; b < WeightDestroy.length; b++){
				WeightDestroy[b]=InitialWeightDestroy[b];
			}
			for(int b = 0; b < WeightRepair.length; b++){
				WeightRepair[b]=InitialWeightRepair[b];
			}
			for (int s = 0; s < weightResetSegments; s++) {
				for(int b = 0; b < WeightDestroy.length; b++){
					scoreDestroy[b]=0;
				}
				for(int b = 0; b < WeightRepair.length; b++){
					scoreRepair[b]=0;
				}
				for (int m = 0; m < sizeSegment; m++) {
					/////////////////////////////////////////////////////////////
					//Select destroy and repair
					currentShift1=currentShift;
					tempsum = 0;
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = WeightDestroy[b];
						tempsum = tempsum + WeightDestroy[b];
					}
					for(int b = 0; b < WeightDestroy.length; b++){
						NomalizedWeightDestroy[b] = NomalizedWeightDestroy[b]/tempsum;
					}
					tempsum=0;
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = WeightRepair[b];
						tempsum = tempsum + WeightRepair[b];
					}
					for(int b = 0; b < WeightRepair.length; b++){
						NomalizedWeightRepair[b] = NomalizedWeightRepair[b]/tempsum;
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightDestroy.length; b++){
						if (NomalizedWeightDestroy[b] > tempsum){
							dest = b+1;
							break;
						} else {
							NomalizedWeightDestroy[b+1] = NomalizedWeightDestroy[b+1] + NomalizedWeightDestroy[b];
						}
					}
					
					tempsum = randomRemoval.nextDouble();
					for(int b = 0; b < WeightRepair.length; b++){
						if (NomalizedWeightRepair[b] > tempsum){
							rep = b+1;
							break;
						} else {
							NomalizedWeightRepair[b+1] = NomalizedWeightRepair[b+1] + NomalizedWeightRepair[b];
						}
					}
					
					//dest = randomRemoval.nextInt(6)+1;
					//rep = randomRemoval.nextInt(4)+1;
					temp.totalShiftCost=-1;
					evaluate = 0;
					attemptDestroy[dest-1]++;
					attemptRepair[rep-1]++;
					if (destroyPossible == 0){
						dest = randomRemoval.nextInt(5)+1;
					}
					dest=4;
					/////////////////////////////////////////////////////////////
					//Destroy
					if (dest==1){
						// remove random vehicles on deck
						chosenRandom = randomRemoval.nextDouble();
						chosenRandom = chosenRandom*maxDestroyPercentage;
						stowageplan.destroyOperator1(chosenRandom, Cargoes);
					}
					
					if (dest==2){
						// remove random vehicles from a set of cargoes with different weighted removal factor
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						stowageplan.destroyOperator2(cargoRandom, Cargoes); 
					}
					
					if (dest==3){
						// remove random vehicles for a given port and a set of cargoes
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						for (int c = 0; c < stowageplan.nCargoes; c++) {
							this.cargoRandom[c] = randomRemoval.nextDouble()*destroy2temp;
						}
						port = randomRemoval.nextInt(stowageplan.nPorts) + 1;
						stowageplan.destroyOperator3(port, cargoRandom, Cargoes); 
					}
					
					if (dest==4){
						// remove vehicles within the given square
						int i_start = 0;
						int j_start = 0;
						int i_end = stowageplan.nRows;
						int j_end = stowageplan.nRows;
						stowageplan.destroyOperator4(i_start,j_start,i_end,j_end,Cargoes); 
					}
					
					if (dest==5){
						// remove vehicles that do not have a neighbor of a similar type.
						stowageplan.destroyOperator5(Cargoes); 
					}
					
					if (dest==6){
						destroy2temp = maxDestroyPercentage*randomRemoval.nextDouble();
						prcShiftCost = randomRemoval.nextDouble()*destroy2temp;
						prcRouteCost = randomRemoval.nextDouble()*destroy2temp;
						prcNumShift = randomRemoval.nextDouble()*destroy2temp;
						stowageplan.destroyOperator6(prcShiftCost, prcRouteCost, prcNumShift, temp, Cargoes);
					}
					
		
					////////////////////////////////////////////////////////////
					//Repair
					rep =1;
					if (rep==1){
						// GRASP-repair
						stowageplan.repairOperator1(stowageplan, Cargoes, maxRunTimeRepair,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==2){
						// Neighbors - then GRASP
						stowageplan.repairOperator2(stowageplan, Cargoes, maxRunTimeRepair, deltaWeight, InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					}
					
					if (rep==3){
						// Placement
						stowageplan.repairOperator3(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
					if (rep==4){
						// Random
						stowageplan.repairOperator4(stowageplan, possibleSquares, Cargoes, exitI, exitJ, UnusableSpace, ExitSquares);
					}
					
				
					//Her skal vi evaluere placement og grouping.
					stowageplan.calculateGrouing(Cargoes);
					stowageplan.calculatePlacement(Cargoes);
					thisGroup = stowageplan.groupObjective;
					thisPlacement = stowageplan.placementObjective;
					
					if(thisGroup*(1+percentGrouping)>currentGroup){
						evaluate=1;
					}
					
					if(thisPlacement<currentPlacement*(1+percentPlacement)){
						evaluate=1;
					}
					evaluate = 1;
					destroyPossible = 0;
					
					//Evaluate solution by Dijkstra
					
					if (stowageplan.feasible==1 && evaluate == 1){
						destroyPossible = 1;
						stowageplan.setNewVehiclePlacement(Cargoes);
						temp = new ShiftingResult(stowageplan);
						temp.dijkstra(stowageplan, possibleSquaresWithExit, Cargoes, exitI, exitJ);
					}
					
					
					//Evaluerer resultat
					
					if (currentShift<=temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						simulated = Math.exp(-(temp.totalShiftCost-bestShift)/temperature);
						//System.out.println(simulated);
						simulatedRandom = randomRemoval.nextDouble();
						//System.out.println(simulatedRandom);
						if (simulated>simulatedRandom){
							//System.out.println("Accepted!!!!!");
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							currentStowagePlan.calculateGrouing(Cargoes);
							currentStowagePlan.calculatePlacement(Cargoes);
							currentGroup = currentStowagePlan.groupObjective;
							currentPlacement = currentStowagePlan.placementObjective;
							currentShift = temp.totalShiftCost;
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score3;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score3;
						}
					} 
					
					if (currentShift>temp.totalShiftCost && stowageplan.feasible==1 && evaluate ==1){
						//System.out.println("Feasible, and better! This shiftCost: " + temp.totalShiftCost + ". Best shiftCost: " + currentShift);
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									currentStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
								}
							}
						}
						currentStowagePlan.calculateGrouing(Cargoes);
						currentStowagePlan.calculatePlacement(Cargoes);
						currentGroup = currentStowagePlan.groupObjective;
						currentPlacement = currentStowagePlan.placementObjective;
						currentShift=temp.totalShiftCost;
						if (bestShift>temp.totalShiftCost){
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score1;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score1;
						} else {
							scoreDestroy[dest-1]=scoreDestroy[dest-1]+score2;
							scoreRepair[rep-1]=scoreRepair[rep-1]+score2;
						}
						if (bestShift>temp.totalShiftCost){
							for(int i = 0; i < stowageplan.nRows; i++){
								for(int j = 0; j < stowageplan.nColumns; j++){
									for(int c = 0; c < stowageplan.nCargoes; c++){
										bestStowagePlan.flowX[i][j][c]=stowageplan.flowX[i][j][c];
									}
								}
							}
							bestShift=temp.totalShiftCost;
						}
						
					} 
					
					if (stowageplan.feasible==0 && evaluate ==1){	
						//Legg inn simulated annihling her
						//System.out.println("Infeasible");
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					if (evaluate == 0){
						for(int i = 0; i < stowageplan.nRows; i++){
							for(int j = 0; j < stowageplan.nColumns; j++){
								for(int c = 0; c < stowageplan.nCargoes; c++){
									stowageplan.flowX[i][j][c] = currentStowagePlan.flowX[i][j][c];
								}
							}
						}
						temp.totalShiftCost=-1;
						scoreDestroy[dest-1]=scoreDestroy[dest-1]+score4;
						scoreRepair[rep-1]=scoreRepair[rep-1]+score4;
					}
					
					System.out.println((n+1) + "\t" + "\t" + currentShift1  + "\t" + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + "\t" + currentShift  + "\t" + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3]);
					writer.println((n+1) + "\t" + currentShift1  + "\t" + dest  + "\t" + rep  + "\t" + temp.totalShiftCost + "\t" + currentShift  + "\t" + WeightDestroy[0]  + "\t" + WeightDestroy[1]  + "\t" + WeightDestroy[2]  + "\t" + WeightDestroy[3]  + "\t" + WeightDestroy[4]  + "\t" + WeightDestroy[5]  + "\t" + WeightRepair[0]  + "\t" + WeightRepair[1]  + "\t" + WeightRepair[2]  + "\t" + WeightRepair[3]);
					if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
						q=1;
						break;
					}
					n++;
					temperature = temperature*coolingRate;
				}
				if (currentShift == 0 || (System.currentTimeMillis()-startTime)>runTimeALNS){
					q=1;
					break;
				}
				// Her slutter segmentet, m oppdatere vekter.
				for(int b = 0; b < WeightDestroy.length; b++){
					if (attemptDestroy[b]!=0){
						WeightDestroy[b] = WeightDestroy[b]*(1-r) + r*scoreDestroy[b]/attemptDestroy[b];
					} else {
						WeightDestroy[b] = WeightDestroy[b]*(1-r);
					}
				}
				for(int b = 0; b < WeightRepair.length; b++){
					if (attemptRepair[b]!=0){
						WeightRepair[b] = WeightRepair[b]*(1-r) + r*scoreRepair[b]/attemptRepair[b];
					} else {
						WeightRepair[b] = WeightRepair[b]*(1-r);
					}
				}
			}
		}
		
		
		
		
		
		
		
		
		bestStowagePlan.printFlowX(Cargoes, UnusableSpace, ExitSquares);
		bestStowagePlan.printFlowXToFile(Cargoes, UnusableSpace, ExitSquares);
		PRshiftCost = bestShift;
		long endTime = System.currentTimeMillis()-startTime;
		
		
		
		//String PRareaUsedPercentage1 = String.format("%04d", PRareaUsedPercentage);
		
		System.out.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost");
		
		System.out.println("unknown" + "\t" + "\t" + endTime + "\t" + "\t" + PRnOptSet + "\t"  + "\t" + PRchosenOptSet + "\t"  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + "\t" + PRnSquares  + "\t" + "\t" + PRnCargoes  + "\t" + "\t" + PRnCargoesO  + "\t" + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + "\t" + "\t" + PRareaUsed  + "\t" + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + PRshiftCost );
		
		writer.println();
		writer.println("Test instance" + "\t" + "Run Time" + "\t" + "n Opt set" + "\t" + "Chosen opt set" + "\t" + "nRows" + "\t" + "nColumns" + "\t" + "nSquares" + "\t" + "# Cargoes" + "\t" + "# Opt Cargoes" + "\t" + "Revenue" + "\t" + "Area approx (m^2)" + "\t" + "Area used" + "\t" + "Area used (%)" + "\t" + "ShiftCost" + "\t" + "InitialShiftCost");
		
		writer.println("unknown" + "\t" + endTime + "\t" + PRnOptSet  + "\t" + PRchosenOptSet  + "\t" + PRnRows  + "\t" + PRnColumns  + "\t" + PRnSquares  + "\t" + PRnCargoes  + "\t" + PRnCargoesO  + "\t" + PRrevenue  + "\t" + PRareaApprox  + "\t" + PRareaUsed  + "\t" + PRareaUsedPercentage  + "\t" + PRshiftCost + "\t" + "ShiftCost");
		
		
		
		
		writer.close();
		
	}



}






