public class OptionalSelector1 {
	
	public static void run(int row, int col, int nCargoesM, int nCargoesO, int nPorts, int [][]UnusableSpace, int [][][]possibleSquares, OptionalSet[] OptionalSets, Cargo[] Cargoes, StowagePlan[] stowagePlans, int deltaWeight, long maxruntimePrIter, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares){
		
		
		
		System.out.println("#################");
		System.out.println("#    GRASP      #");
		System.out.println("#################");
		int nCargoes = nCargoesM+nCargoesO;
		int areaFree=0;
		int areaMandatory=0;
		for (int i = 0; i < row; i++){
			for (int j = 0; j < col; j++){
				if (UnusableSpace[i][j]==0){
					areaFree++;
				}
			}
		}
		for (int c = 0; c < nCargoesM; c++) {
			areaMandatory = areaMandatory + Cargoes[c].Area*Cargoes[c].NumberVehicle;
		}
		
		int possibleOptionalSetCounter=0;
		for (int o = 0; o < Math.pow(2,nCargoesO); o++) {
			if (OptionalSets[o].AreaUsage<(areaFree-areaMandatory)){
				possibleOptionalSetCounter++;
			}
		}
			
	
	
		int[][] sortedOptionalSets= new int [possibleOptionalSetCounter][2];
		possibleOptionalSetCounter=0;
		int bestOptionalSet = 0;
		int bestOptionalRev = 0;
		for (int o = 0; o < Math.pow(2,nCargoesO); o++) {
			if (OptionalSets[o].AreaUsage<(areaFree-areaMandatory)){
				sortedOptionalSets[possibleOptionalSetCounter][0]=OptionalSets[o].Revenue;
				sortedOptionalSets[possibleOptionalSetCounter][1]=o;
				possibleOptionalSetCounter++;
				if (bestOptionalRev<OptionalSets[o].Revenue){
					bestOptionalRev = OptionalSets[o].Revenue;
					bestOptionalSet = o;
				}
			}
		}
		//Sort sortedOptionalSets by revenue from min to max.
		java.util.Arrays.sort(sortedOptionalSets, new java.util.Comparator<int[]>() {
		    public int compare(int[] a, int[] b) {
		        return Double.compare(a[0], b[0]);
		    }
		});
		//matrixPrint(sortedOptionalSets);
	
		//HER STARTER VI
		int s = 0;
		//Finn beste feasible
		int delta = sortedOptionalSets.length/2;
		int tempOptionalCargo=0;
		int lastFeasibleOptionalSet = 0;
		int selectedOptionalSet = sortedOptionalSets.length/2;
		
		
		
		System.out.println("Revenue" + "\t" + "OptionalSet" + "\t" + "Run Time" + "\t" + "Feasible");
		
		int chosenOptCargo = 0;
		
		//long maxruntimePrIter = 300000/nCargoesO;
		
		
		StowagePlan temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
		StowagePlan temp2 = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
		while (delta>0){
			long iterTime = System.currentTimeMillis();
			tempOptionalCargo = sortedOptionalSets[selectedOptionalSet][1];
			temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
			//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
			GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
			
			delta = (int) Math.floor(delta/2);
			if (temp.feasible==1){
				temp2 = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
				for (int c = 0; c < nCargoes; c++) {
					for (int i = 0; i < row; i++){
						for (int j = 0; j < col; j++){
							temp2.flowX[i][j][c]=temp.flowX[i][j][c];
						}
					}
				}
				selectedOptionalSet = Math.min((selectedOptionalSet + delta), sortedOptionalSets.length-1);
				lastFeasibleOptionalSet = tempOptionalCargo;
				if (lastFeasibleOptionalSet == bestOptionalSet){
					break;
				}
				
			} else {
				selectedOptionalSet = Math.max((selectedOptionalSet - delta), 0);
			}
					
			//System.out.println("DELTA==" +delta);
			if (delta == 0){
				if (temp.feasible==1){
					//System.out.println("VIERHER1" );
					tempOptionalCargo = sortedOptionalSets[selectedOptionalSet+1][1];
					temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
					//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
					
					GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					if (temp.feasible==1){
						lastFeasibleOptionalSet = tempOptionalCargo;
					}
				}
				if (temp.feasible==0 && selectedOptionalSet!=0) {
					tempOptionalCargo = sortedOptionalSets[selectedOptionalSet-1][1];
					temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
					//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
					GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					if (temp.feasible==1){
						lastFeasibleOptionalSet = tempOptionalCargo;
					}	
				}
			}
			String c1 = "Yes";
			if (temp.feasible==0){
				c1 = "No";
			}
			System.out.println(OptionalSets[tempOptionalCargo].Revenue + "\t" + tempOptionalCargo + "\t" + "\t" + (System.currentTimeMillis()-iterTime) + "\t" + "\t" + c1);
			
		}
		
		chosenOptCargo = lastFeasibleOptionalSet;
		
		stowagePlans[s] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, lastFeasibleOptionalSet,nPorts, Cargoes,possibleSquares);
		for (int c = 0; c < nCargoes; c++) {
			for (int i = 0; i < row; i++){
				for (int j = 0; j < col; j++){
					if (temp.feasible==1){
						stowagePlans[s].flowX[i][j][c]=temp.flowX[i][j][c];
					} else {
						stowagePlans[s].flowX[i][j][c]=temp2.flowX[i][j][c];
					}
					
				}
			}
		}
		stowagePlans[s].areaNotPlaced=0;
		stowagePlans[s].feasible=0;
		s++;
		int setSelector = 0;
		for (int o = 0; o < sortedOptionalSets.length; o++) {
			if (sortedOptionalSets[o][1]==lastFeasibleOptionalSet){
				setSelector = o;
			}
		}		
		//System.out.println("Best optset found, searching for remaining 3 sets");
		//Her finner vi de n nest beste lsningene. n settes i main.
		
		if (setSelector == 0){
			for (int i = s; i < stowagePlans.length; i++) {
				stowagePlans[i] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, 0,nPorts, Cargoes,possibleSquares);
			}
		}
		while (s<stowagePlans.length && setSelector>0 ){
			setSelector--;
			tempOptionalCargo = sortedOptionalSets[setSelector][1];
			temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
			GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
			if (temp.feasible==1){
				stowagePlans[s] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
				for (int c = 0; c < nCargoes; c++) {
					for (int i = 0; i < row; i++){
						for (int j = 0; j < col; j++){
							stowagePlans[s].flowX[i][j][c]=temp.flowX[i][j][c];
						}
					}
				}
				stowagePlans[s].areaNotPlaced=0;
				stowagePlans[s].feasible=0;
				s++;
			}
			if (setSelector == 0){
				for (int i = s; i < stowagePlans.length; i++) {
					stowagePlans[i] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, 0,nPorts, Cargoes,possibleSquares);
				}
			}
			
			
		}
		
		System.out.println();
		System.out.println("Chosen optional set: " + chosenOptCargo + ". 1 if cargo is carried, 0 otherwise.");
		OptionalSets[chosenOptCargo].print();
		
		
	}
	

	public static void runWithoutPrint(int row, int col, int nCargoesM, int nCargoesO, int nPorts, int [][]UnusableSpace, int [][][]possibleSquares, OptionalSet[] OptionalSets, Cargo[] Cargoes, StowagePlan[] stowagePlans, int deltaWeight, long maxruntimePrIter, int[] InitialWeightParamSearchDir, int[] InitialWeightParamRandom, int[] InitialWeightParamCandidateListLength, int[] InitialWeightParamAreaOrSquares, int optionalval){
		
		
		
		int nCargoes = nCargoesM+nCargoesO;
		int areaFree=0;
		int areaMandatory=0;
		for (int i = 0; i < row; i++){
			for (int j = 0; j < col; j++){
				if (UnusableSpace[i][j]==0){
					areaFree++;
				}
			}
		}
		for (int c = 0; c < nCargoesM; c++) {
			areaMandatory = areaMandatory + Cargoes[c].Area*Cargoes[c].NumberVehicle;
		}
		
		int possibleOptionalSetCounter=0;
		for (int o = 0; o < Math.pow(2,nCargoesO); o++) {
			if (OptionalSets[o].AreaUsage<(areaFree-areaMandatory)){
				possibleOptionalSetCounter++;
			}
		}
			
	
	
		int[][] sortedOptionalSets= new int [possibleOptionalSetCounter][2];
		possibleOptionalSetCounter=0;
		int bestOptionalSet = 0;
		int bestOptionalRev = 0;
		for (int o = 0; o < Math.pow(2,nCargoesO); o++) {
			if (OptionalSets[o].AreaUsage<(areaFree-areaMandatory)){
				sortedOptionalSets[possibleOptionalSetCounter][0]=OptionalSets[o].Revenue;
				sortedOptionalSets[possibleOptionalSetCounter][1]=o;
				possibleOptionalSetCounter++;
				if (bestOptionalRev<OptionalSets[o].Revenue){
					bestOptionalRev = OptionalSets[o].Revenue;
					bestOptionalSet = o;
				}
			}
		}
		//Sort sortedOptionalSets by revenue from min to max.
		java.util.Arrays.sort(sortedOptionalSets, new java.util.Comparator<int[]>() {
		    public int compare(int[] a, int[] b) {
		        return Double.compare(a[0], b[0]);
		    }
		});
		//matrixPrint(sortedOptionalSets);
	
		//HER STARTER VI
		int s = 0;
		//Finn beste feasible
		int delta = sortedOptionalSets.length/2;
		int tempOptionalCargo=0;
		int lastFeasibleOptionalSet = 0;
		int selectedOptionalSet = sortedOptionalSets.length/2;
		
		
		
		
		int chosenOptCargo = 0;
		
		//long maxruntimePrIter = 300000/nCargoesO;
		int deltaexeption = 0;
		
		StowagePlan temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
		StowagePlan temp2 = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
		while (delta>0){
			long iterTime = System.currentTimeMillis();
			tempOptionalCargo = sortedOptionalSets[selectedOptionalSet][1];
			temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
			//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
			GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
			if (optionalval == 0){
				delta = (int) Math.floor(delta/2)+1;
				if (deltaexeption == 1){
					delta = 0;
				}
				if ((delta ==1 || delta == 2) && deltaexeption == 0){
					deltaexeption = 1;
				}
			}
			if (optionalval == 1){
				delta = (int) Math.floor(delta/2);
			}
			//
			//System.out.println(delta);
			if (temp.feasible==1){
				temp2 = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
				for (int c = 0; c < nCargoes; c++) {
					for (int i = 0; i < row; i++){
						for (int j = 0; j < col; j++){
							temp2.flowX[i][j][c]=temp.flowX[i][j][c];
						}
					}
				}
				selectedOptionalSet = Math.min((selectedOptionalSet + delta), sortedOptionalSets.length-1);
				lastFeasibleOptionalSet = tempOptionalCargo;
				if (lastFeasibleOptionalSet == bestOptionalSet){
					break;
				}
				
			} else {
				selectedOptionalSet = Math.max((selectedOptionalSet - delta), 0);
			}
					
			//System.out.println("DELTA==" +delta);
			if (delta == 0){
				if (temp.feasible==1){
					//System.out.println("VIERHER1" );
					tempOptionalCargo = sortedOptionalSets[selectedOptionalSet+1][1];
					temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
					//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
					
					GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					if (temp.feasible==1){
						lastFeasibleOptionalSet = tempOptionalCargo;
					}
				}
				if (temp.feasible==0 && selectedOptionalSet!=0) {
					tempOptionalCargo = sortedOptionalSets[selectedOptionalSet-1][1];
					temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
					//System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!Vi kjrer for optSet: " + tempOptionalCargo);
					GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
					if (temp.feasible==1){
						lastFeasibleOptionalSet = tempOptionalCargo;
					}	
				}
			}
			String c1 = "Yes";
			if (temp.feasible==0){
				c1 = "No";
			}
			
		}
		
		chosenOptCargo = lastFeasibleOptionalSet;
		
		stowagePlans[s] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, lastFeasibleOptionalSet,nPorts, Cargoes,possibleSquares);
		for (int c = 0; c < nCargoes; c++) {
			for (int i = 0; i < row; i++){
				for (int j = 0; j < col; j++){
					if (temp.feasible==1){
						stowagePlans[s].flowX[i][j][c]=temp.flowX[i][j][c];
					} else {
						stowagePlans[s].flowX[i][j][c]=temp2.flowX[i][j][c];
					}
					
				}
			}
		}
		stowagePlans[s].areaNotPlaced=0;
		stowagePlans[s].feasible=0;
		s++;
		int setSelector = 0;
		for (int o = 0; o < sortedOptionalSets.length; o++) {
			if (sortedOptionalSets[o][1]==lastFeasibleOptionalSet){
				setSelector = o;
			}
		}		
		//System.out.println("Best optset found, searching for remaining 3 sets");
		//Her finner vi de n nest beste lsningene. n settes i main.
		
		if (setSelector == 0){
			for (int i = s; i < stowagePlans.length; i++) {
				stowagePlans[i] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, 0,nPorts, Cargoes,possibleSquares);
			}
		}
		while (s<stowagePlans.length && setSelector>0 ){
			setSelector--;
			tempOptionalCargo = sortedOptionalSets[setSelector][1];
			temp = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
			GRASP.runWithTimer(temp,Cargoes,maxruntimePrIter,deltaWeight,InitialWeightParamSearchDir,InitialWeightParamRandom, InitialWeightParamCandidateListLength, InitialWeightParamAreaOrSquares);
			if (temp.feasible==1){
				stowagePlans[s] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, tempOptionalCargo,nPorts, Cargoes,possibleSquares);
				for (int c = 0; c < nCargoes; c++) {
					for (int i = 0; i < row; i++){
						for (int j = 0; j < col; j++){
							stowagePlans[s].flowX[i][j][c]=temp.flowX[i][j][c];
						}
					}
				}
				stowagePlans[s].areaNotPlaced=0;
				stowagePlans[s].feasible=0;
				s++;
			}
			if (setSelector == 0){
				for (int i = s; i < stowagePlans.length; i++) {
					stowagePlans[i] = new StowagePlan(row,col,nCargoesM,nCargoesO,OptionalSets, 0,nPorts, Cargoes,possibleSquares);
				}
			}
			
			
		}
		
		
		
	}
	

	
public static void matrixPrint(int[][] matrix) {
		for (int i = 0; i < matrix.length; i++) {
			System.out.print("-----");
		}
		System.out.println();
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[0].length; j++) {
				System.out.print("| " + matrix[i][j] + " ");
			}
			System.out.print("|");
			System.out.println();
			for (int i1 = 0; i1 < matrix.length; i1++) {
				System.out.print("-----");
			}
			System.out.println();
		}
	}
}
