import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

public class ParameterTest {
	int[][][][] results;
	ParameterTest(int numberDirections, int numberRandom, int candidateListLength){
		results = new int [numberDirections][numberRandom+1][candidateListLength][2];
	}
	void run(StowagePlan stowageplan, int numberOfIterations, Cargo[] Cargoes, int[][][] possibleSquares){
		int count = 0;
		double tempRlength = results[0].length-1;
		for (int d = 0; d < results.length; d++) {
			for (int r = 0; r < results[0].length; r++) {
				count++;
				System.out.println(168-count);
				for (int l = 0; l < results[0][0].length; l++) {
					for (int o = 0; o < 2; o++) {
						for (int n = 0; n < numberOfIterations; n++) {
							double tempR = r;
							stowageplan.GRASPconstruction(possibleSquares, Cargoes, d, tempR/tempRlength, l+1, o);
							//stowageplan.constructionHeuristic(possibleSquares, Cargoes, 0, 0, 1, 1);
							//test1      .constructionHeuristic(possibleSquares, Cargoes,searchDirParam, randomParam,candidateListLength,areaOrSquares);
							if (stowageplan.feasible == 1){
								results[d][r][l][o]++;
							}
						}
					}
				}
			}
		}
	}
	
	void printEveryInstance(){
		double tempRlength = results[0].length-1;
		System.out.println("Dir Ran Lis Obj Res ");
		for (int d = 0; d < results.length; d++) {
			for (int r = 0; r < results[0].length; r++) {
				for (int l = 0; l < results[0][0].length; l++) {
					for (int o = 0; o < 2; o++) {
						System.out.println(d+ "   " + (r/tempRlength) + " " + (l+1) + "    " + o + "   " + results[d][r][l][o] );
					}
				}
			}
		}
	}
	
	void printEveryInstanceToFile() throws FileNotFoundException, UnsupportedEncodingException{
		PrintWriter writer = new PrintWriter("graspParam.txt", "UTF-8");
		double tempRlength = results[0].length-1;
		System.out.println("Dir Ran Lis Obj Res ");
		for (int d = 0; d < results.length; d++) {
			for (int r = 0; r < results[0].length; r++) {
				for (int l = 0; l < results[0][0].length; l++) {
					for (int o = 0; o < 2; o++) {
						writer.println(d+ "   " + (r/tempRlength) + " " + (l+1) + "    " + o + "   " + results[d][r][l][o] );
					}
				}
			}
		}
	}
	
	
	
	void printOverallResults(){
		//DENNE ER UFERDIG
		
		int bestDir=-1;
		double bestRandom=-1;
		int bestLength=-1;
		int bestObjective=-1;
		int tempDir;
		double tempRandom;
		int tempLength;
		int tempObjective;
		int bestDirParam=-1;
		double bestRandomParam=-1;
		int bestLengthParam=-1;
		int bestObjectiveParam=-1;
		for (int d = 0; d < results.length; d++) {
			tempDir = 0;
			for (int r = 0; r < results[0].length; r++) {
				for (int l = 0; l < results[0][0].length; l++) {
					for (int o = 0; o < 2; o++) {
						if (results[d][r][l][o] == 1){
							tempDir++;
						}
					}
				}
			}
			if (tempDir>bestDir && tempDir != 0){
				bestDir = tempDir;
				bestDirParam = d;
			}
		}
		if (bestDir==-1){
			System.out.println("Best direction = NAN");
		} else {
			System.out.println("Best direction = " + bestDirParam);
		}
		
		
		
		for (int r = 0; r < results[0].length; r++) {
			tempRandom = 0;
			for (int d = 0; d < results.length; d++) {
				for (int l = 0; l < results[0][0].length; l++) {
					for (int o = 0; o < 2; o++) {
						if (results[d][r][l][o] == 1){
							tempRandom++;
						}
					}
				}
			}
			if (tempRandom>bestRandom && tempRandom != 0){
				bestRandom = tempRandom;
				double r1 = r;
				double rLength = results[0].length;
				bestRandomParam = r1/rLength;
			}
		}
		if (bestRandom==-1){
			System.out.println("Best random value = NAN");
		} else {
			System.out.println("Best random value = " + bestRandomParam);
		}
		
	}
	
	
}
