import java.io.File;
import java.io.IOException;
import java.util.Scanner;

public class ReadAndSet {
	public static void setCargoes(Cargo[]Cargoes, int[] NumberVehicle, int[] SquaresL, int[] SquaresW, int[] LoadingPort, int[] UnloadingPort, int[] CargoWeight, int[]RevenueOptional, int nCargoesM, int nCargoesO){
		for (int c = 0; c < nCargoesO+nCargoesM; c++) {
			if (c >= nCargoesM){
				Cargoes[c] = new Cargo(NumberVehicle[c],SquaresL[c],SquaresW[c],LoadingPort[c],UnloadingPort[c],CargoWeight[c],RevenueOptional[c-nCargoesM]);
			} else {
				Cargoes[c] = new Cargo(NumberVehicle[c],SquaresL[c],SquaresW[c],LoadingPort[c],UnloadingPort[c],CargoWeight[c],0);	
			}
				
		}
	}
	
	public static void setOptionalSets(OptionalSet[] OptionalSets, int nCargoesO, Cargo[] Cargoes, int nCargoesM){
		int binary = (int) Math.pow(2,nCargoesO);
		int[] combinations;
		combinations = new int[nCargoesO];
		int foo = 0;
		char ch;
		int voo = 0;
		for(int j=0; j < 2; j++){
			for(int i=binary/2; i < binary; i++){
				if (j == 1) {
					String temp = Integer.toBinaryString(i);
					for(int c=0; c < nCargoesO; c++){
						ch = temp.charAt(c);
						foo = Character.getNumericValue(ch);
	    				combinations[c] = foo;
					}
					OptionalSets[i]= new OptionalSet(combinations,Cargoes,nCargoesM);
				} else {
					String temp = Integer.toBinaryString(i);
					for(int c=1; c < nCargoesO; c++){
						ch = temp.charAt(c);
						foo = Character.getNumericValue(ch);
	    				combinations[c] = foo;
					}
					combinations[0]=0;
					voo = i-(binary/2);
					OptionalSets[voo]= new OptionalSet(combinations,Cargoes,nCargoesM);
				}
				
			}    		
		}
	}
	
	public static void setPossibleSquaresWithExit(int[][][] possibleSquaresWithExit, int nCargoes, Cargo[]Cargoes, int[][] ExitSquares, int[][] UnusableSpace){
		for (int c = 0; c < nCargoes; c++) {
			for (int i = 0; i < possibleSquaresWithExit.length; i++) {
				for (int j = 0; j < possibleSquaresWithExit[0].length; j++) {
					int possible = 0;
					if (i+Cargoes[c].SquaresL-1<possibleSquaresWithExit.length && j+Cargoes[c].SquaresW-1<possibleSquaresWithExit[0].length){
						for (int a = i; a <= i+Cargoes[c].SquaresL-1; a++) {
							for (int b = j; b <= j+Cargoes[c].SquaresW-1; b++) {
								if (UnusableSpace[a][b]==1){
									possible++;
								}
							}
						}
					} else {
						possible++;
					}
					if (possible==0){
						possibleSquaresWithExit[i][j][c] = 1;					}
				}
			}
		}
	}
	
	public static void setPossibleSquares(int[][][] possibleSquares, int nCargoes, Cargo[]Cargoes, int[][] ExitSquares, int[][] UnusableSpace){
		for (int c = 0; c < nCargoes; c++) {
			for (int i = 0; i < possibleSquares.length; i++) {
				for (int j = 0; j < possibleSquares[0].length; j++) {
					int possible = 0;
					if (i+Cargoes[c].SquaresL-1<possibleSquares.length && j+Cargoes[c].SquaresW-1<possibleSquares[0].length){
						for (int a = i; a <= i+Cargoes[c].SquaresL-1; a++) {
							for (int b = j; b <= j+Cargoes[c].SquaresW-1; b++) {
								if (UnusableSpace[a][b]==1){
									possible++;
								}
								if (ExitSquares[a][b]==1){
									possible++;
								}
							}
						}
					} else {
						possible++;
					}
					if (possible==0){
						possibleSquares[i][j][c] = 1;					}
				}
			}
		}
	}
	
	public static void setParameters(int[]SquaresL, int[]SquaresW, int[]LoadingPort, int[]UnloadingPort, int[]NumberVehicle, int[]CargoWeight, int[]RevenueOptional, int[][]UnusableSpace, int[][]ExitSquares, int[] DijkExit, String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//SquaresL
		int linejumps = 7;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < SquaresL.length; i++) {
			SquaresL[i]=Scan.nextInt();
		}
		
		//SquaresW
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < SquaresW.length; i++) {
			SquaresW[i]=Scan.nextInt();
		}
		
		//LoadingPort
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < LoadingPort.length; i++) {
			LoadingPort[i]=Scan.nextInt();
		}
		
		//UnloadingPort
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < UnloadingPort.length; i++) {
			UnloadingPort[i]=Scan.nextInt();
		}
		
		//NumberVehicle
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < NumberVehicle.length; i++) {
			NumberVehicle[i]=Scan.nextInt();
		}
		
		//CargoWeight
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < CargoWeight.length; i++) {
			CargoWeight[i]=Scan.nextInt();
		}
		
		//RevenueOptional
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < RevenueOptional.length; i++) {
			RevenueOptional[i]=Scan.nextInt();
		}
		
		//UnusableSpace
		linejumps = 4;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		for (int i = 0; i < UnusableSpace.length; i++) {
			for (int j = 0; j < UnusableSpace[0].length; j++) {
				UnusableSpace[i][j]=Scan.nextInt();
			}
			Scan.nextLine();
		}
		//ExitSquares
		linejumps = 3;
		for (int i = 0; i < linejumps; i++) {
			Scan.nextLine();
		}
		int cou = 0;
		int cou1 = 0;
		while (cou==0){
			String temp = Scan.next();
			if (temp.equals("]")){
				break;
			}
			temp = temp.substring(1, temp.length()-1);
			int indexofchar=temp.indexOf(",");
			String i2 = temp.substring(0, indexofchar);
			String j2 = temp.substring(indexofchar+1, temp.length());
			int i1 = Integer.parseInt(i2);
			int j1 = Integer.parseInt(j2);
			ExitSquares[i1-1][j1-1] = 1;
			if (cou1==0){
				cou1++;
				DijkExit[0]=i1-1;
				DijkExit[1]=j1-1;
			}
			Scan.nextLine();
			
		}
	}
	
	public static int nRowsRead(String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//which line to read
		int line = 1;
		for (int i = 0; i < line-1; i++) {
			Scan.nextLine();
		}
		Scan.next();
		Scan.next();
		int read = Scan.nextInt();
		return read;
	}
	
	public static int nColumnsRead(String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//which line to read
		int line = 2;
		for (int i = 0; i < line-1; i++) {
			Scan.nextLine();
		}
		Scan.next();
		Scan.next();
		int read = Scan.nextInt();
		return read;
	}
	
	public static int nCargoesMRead(String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//which line to read
		int line = 3;
		for (int i = 0; i < line-1; i++) {
			Scan.nextLine();
		}
		Scan.next();
		Scan.next();
		int read = Scan.nextInt();
		return read;
	}
	
	public static int nCargoesORead(String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//which line to read
		int line = 4;
		for (int i = 0; i < line-1; i++) {
			Scan.nextLine();
		}
		Scan.next();
		Scan.next();
		int read = Scan.nextInt();
		return read;
	}
	
	public static int nPortsRead(String input) throws IOException{
		Scanner Scan = new Scanner(new File(input));
		//which line to read
		int line = 5;
		for (int i = 0; i < line-1; i++) {
			Scan.nextLine();
		}
		Scan.next();
		Scan.next();
		int read = Scan.nextInt();
		return read;
	}
	
	
}
