import java.util.Comparator;

public class SquareCostComparator implements Comparator<Placement>
	{
	    @Override
	    public int compare(Placement x, Placement y)
	    {
	        // Assume neither string is null. Real code should
	        // probably be more robust
	        // You could also just return x.length() - y.length(),
	        // which would be more efficient.
	        if (x.SquareCost < y.SquareCost)
	        {
	            return -1;
	        }
	        if (x.SquareCost > y.SquareCost)
	        {
	            return 1;
	        }
	        return 0;
	    }
	}